
#include <iostream>
#include <vector>
#include <conio.h>
#include "histogram.h"
#include "text.h"
#include <stdio.h>
#include "svg.h"
#include <curl/curl.h>
#include <sstream>
#include <string>
using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};


Input
input_data(istream& inp, bool prompt){
    size_t number_count;
    if (prompt){
        cerr << "Enter number count: ";
    }
    inp >> number_count; //- 

    Input in;
    in.numbers.resize(number_count);

    for (size_t i = 0; i < number_count; i++)
    {
        if (prompt){
                cerr << "Enter Num[" << i << "]: ";
        }

        inp >> in.numbers[i]; // 
    }
    if (prompt) {
            cerr << "Enter bin count: ";
    }
    inp >> in.bin_count; //- 
    return in;
}
size_t
write_data(void* items, size_t item_size, size_t item_count, void* ctx) {
    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    size_t data_size = item_size * item_count;
    (*buffer).write(reinterpret_cast<const char*>(items), data_size);
    return data_size;
}

Input
download(const string& adress){
    stringstream buffer;
    CURL* curl = curl_easy_init();
    if(curl) {

        CURLcode res;
        curl_easy_setopt(curl, CURLOPT_URL, adress.c_str());
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);
        res = curl_easy_perform(curl);
        if (res != CURLE_OK){
            cerr << curl_easy_strerror(res);
            exit(1);
        }
        curl_easy_cleanup(curl);
    }

    return input_data(buffer, false);
}


int main(int argc, char* argv[])
{
    curl_global_init(CURL_GLOBAL_ALL);
    string color = "base";
    Input in;
    if (argc > 1) {
        for (size_t i = 0; i < argc; i += 1){
            if (strcmp(argv[i], "-fill") == 0){
                if (i - 1 < 1){
                    in = download(argv[i + 2]);
                    color = argv[i + 2];
                }
                else{
                    if (i + 1 >= argc){
                        cerr << "Error: please enter color";
                        exit(1);
                    }
                    else{
                        in = download(argv[i - 1]);
                        color = argv[i + 1];
                    }
                }
            }
        }
    }
     else {
        in = input_data(cin, true);
    }

    auto bins = make_histogram(in.numbers, in.bin_count);
    auto borders = make_borders(in.numbers, in.bin_count);
    show_histogram_svg(bins, borders, in.bin_count, color);
    getch();
    return 0;
}
